// EtchASketchView.cpp : implementation of the CEtchASketchView class
//

#include "stdafx.h"
#include "EtchASketch.h"

#include "EtchASketchDoc.h"
#include "EtchASketchView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEtchASketchView

IMPLEMENT_DYNCREATE(CEtchASketchView, CView)

BEGIN_MESSAGE_MAP(CEtchASketchView, CView)
	//{{AFX_MSG_MAP(CEtchASketchView)
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEtchASketchView construction/destruction

CEtchASketchView::CEtchASketchView()
{
	// TODO: add construction code here

}

CEtchASketchView::~CEtchASketchView()
{
}

BOOL CEtchASketchView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CEtchASketchView drawing

void CEtchASketchView::OnDraw(CDC* pDC)
{
	int i;

	//Get the document
	CEtchASketchDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// Draw the lines
	pDoc->psList->resetLocation();

	if(pDoc->psList->getNumPoints() != 0) {
		pDC->MoveTo(pDoc->psList->getNextPoint());
	}

	for(i = 1; i < pDoc->psList->getNumPoints(); i++) {
		pDC->LineTo(pDoc->psList->getNextPoint());
	}
}

/////////////////////////////////////////////////////////////////////////////
// CEtchASketchView diagnostics

#ifdef _DEBUG
void CEtchASketchView::AssertValid() const
{
	CView::AssertValid();
}

void CEtchASketchView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CEtchASketchDoc* CEtchASketchView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CEtchASketchDoc)));
	return (CEtchASketchDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEtchASketchView message handlers

void CEtchASketchView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	CPoint	pPrevious;
	BOOL	bInverse = FALSE;
	int		iTemp;
			
	// get the point in the window
	CEtchASketchDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	if(pDoc->psList->getNumPoints() == pDoc->psList->getMaxPoints() - 1)
		return;


	pPrevious = pDoc->psList->getThisPoint();
	if((point.x == pPrevious.x) && (point.y == pPrevious.y)) {
		//Do not add similar points
		CView::OnLButtonUp(nFlags, point);
		return;
	}
	
	//check if the points are too separate
	if(pDoc->psList->getNumPoints() > 0) {
		if((abs(point.x - pPrevious.x) > 125) || (abs(point.y - pPrevious.y) > 125)) {
			if((abs(point.x - pPrevious.x)) > (abs(point.y - pPrevious.y))) {
				if(point.x - pPrevious.x < 0) {
					CPoint pTemp;
					pTemp = point;
					point = pPrevious;
					pPrevious = pTemp;
					bInverse = TRUE;
				}
				if((point.y - pPrevious.y) == 0) iTemp = 0; 
				else iTemp = (int)((point.y - pPrevious.y) / (double)(point.x - pPrevious.x) * 125);
				
				OnLButtonUp(nFlags,CPoint(pPrevious.x + 125,pPrevious.y + iTemp));
				if(bInverse) {
					CPoint pTemp;
					pTemp = point;
					point = pPrevious;
					pPrevious = pTemp;
				}				
			}
			else {
				if(point.y - pPrevious.y < 0) {
					CPoint pTemp;
					pTemp = point;
					point = pPrevious;
					pPrevious = pTemp;
					bInverse = TRUE;
				}
				if((point.x - pPrevious.x) == 0) iTemp = 0; 
				else iTemp = (int)((point.x - pPrevious.x) / (double)(point.y - pPrevious.y) * 125);
				
				OnLButtonUp(nFlags,CPoint(pPrevious.x + iTemp, pPrevious.y + 125));
				if(bInverse) {
					CPoint pTemp;
					pTemp = point;
					point = pPrevious;
					pPrevious = pTemp;
				}				
			}

			//Add the remaining points
			OnLButtonUp(nFlags, point);
			return;
		}
	}

	if(!pDoc->psList->addPoint(point)) {
		//The point list is full, do not add.
		CView::OnLButtonUp(nFlags, point);
	}

	//since I am adding a point the file is now modified
	pDoc->SetModifiedFlag();

	//Now draw the item
	Invalidate(FALSE);
	CPaintDC pDC(this);

	if(pDoc->psList->getNumPoints() > 1) {
		pDC.MoveTo(pPrevious);
		pDC.LineTo(pDoc->psList->getNextPoint());
	}
	else pDoc->psList->getNextPoint(); //Move one node forward

	CView::OnLButtonUp(nFlags, point);

}
