// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "EtchASketch.h"
#include "SerialPort.h"
#include "EtchASketchDoc.h"
#include "MainFrm.h"
#include "PortException.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_FILE_PROGRAM, OnFileProgram)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void CMainFrame::OnFileProgram() 
{
		unsigned char * readValue = new unsigned char[2];
		readValue[0] = 0;

		//I want to open the thread
		try {
			static CSerialPort		*cspConnection = new CSerialPort();



		//The serial port handler

		//Send the Message
		m_wndStatusBar.SetWindowText("Attempting Handshake");

		//Handshaking
		cspConnection->ReadFromPort(readValue,1);
		cspConnection->SendToPort((unsigned char*)"\xff",1);
	
		//The Timer function
		CTimeSpan timeSpan;
		CTime	startTime = CTime::GetCurrentTime();
		while(readValue[0] == 0) {
			cspConnection->SendToPort((unsigned char*)"\xff",1);
			this->UpdateWindow();
	
			//Timer Adds a timelimit to exit from here
			timeSpan = CTime::GetCurrentTime() - startTime;
			if(timeSpan.GetTotalSeconds() > 5) {
				m_wndStatusBar.SetWindowText("Export timeout: cannot find device!");
				return;
			}
		}

		CEtchASketchDoc * cESD = (CEtchASketchDoc *)GetActiveDocument();
		unsigned char * cStr = cESD->GetPointString();
		if(cStr[0] == 0) {
			m_wndStatusBar.SetWindowText("File is Empty!");
			return;
		}

	if(cStr[0] != '\xff') {
		char Error[50];
		sprintf(Error,"Handshake got! %d",(int)cStr[0]);
		m_wndStatusBar.SetWindowText(Error);
		//return;
	}

		cspConnection->SendToPort(cStr,strlen((const char *)cStr));//(unsigned char*)"I Pity The Fool!",16);//

/*		while(strlen((const char *)cStr)) {

			cspConnection.SendToPort(cStr,1);
			cStr++;
		}
*/
		m_wndStatusBar.SetWindowText("Sending Completed");
		return;

		}
		catch(PortException *e) {
			MessageBox(e->sErrorStr);
			return;
	}
}
